//
// Created by sylwe on 16.07.2024.
//

#ifndef SOLVER2_H
#define SOLVER2_H

#include "Config.h"

class Solver2 {
public:
    Solver2( GraphSP2 _g, int L, int vs, int vt );

    int N; // size of the input graph
    int L; // max length of paths to consider
    int vs, vt;
    GraphSP2 g, revg;
    Config cnf;
    ULL backtracking_states_visited = 0;


    void kernelize();

    static pair<VI,VI> findDistances(GraphSP2 & g, int beg, Mask& S);
    static pair<VI,VI> findDistances(GraphSP2 & g, int beg, VB & S);
    // finds also distances to nodes from S, but does not propagate further
    static pair<VI,VI> findDistancesInclusive(GraphSP2 & g, int beg, Mask S);
    static pair<VI,VI> findDistancesInclusive(GraphSP2 & g, int beg, VB & S);
    static pair<VI,VI> findDistances(GraphSP2 & g, int beg);
    static VI findShortestPath(GraphSP2 & g, int beg, int end, Mask S);

    VBIG solve();

    VBIG splitByDominators();
    VBIG splitBy2NodeSeparator();


    VBIG solveForDAG();

    static bool existsPath( GraphSP2 & g, int a, int b, Mask & S );
    static bool existsPath( GraphSP2 & g, int a, int b, VB & S );


};

#endif //SOLVER2_H
