//
// Created by sylwe on 21/09/2024.
//

#include "DistanceFinder2.h"

void DistanceFinder2::findDistances(GraphSP2 & g, int beg, Mask &S) {
    fill(ALL(considered),false);
    fill(ALL(in_queue),false);
    neigh.clear();

    dst[beg] = 0; par[beg] = -1;
    considered[beg] = true;

    neigh.push_back(beg);

    for( int i=0; i<neigh.size(); i++ ) {
        int v = neigh[i];
        in_queue[v] = false;
        considered[v] = true;

        for( auto & arc : g[v] ) {
            int d = arc.v;
            if( !S[d] && (!considered[d] || (dst[v] + arc.minl() < dst[d]) )  ) {
                dst[d] = dst[v] + arc.minl();
                par[d] = v;
                considered[d] = true;

                if( !in_queue[d] ) {
                    neigh.push_back(d);
                    in_queue[d] = true;
                }
            }
        }
    }
}

void DistanceFinder2::findDistancesInclusive(GraphSP2 & g, int beg, VB &S) {
    fill(ALL(considered),false);
    fill(ALL(in_queue),false);
    neigh.clear();

    dst[beg] = 0; par[beg] = -1;
    considered[beg] = true;

    neigh.push_back(beg);

    for( int i=0; i<neigh.size(); i++ ) {
        int v = neigh[i];
        in_queue[v] = false;
        considered[v] = true;

        for( auto & arc : g[v] ) {
            int d = arc.v;
            if( (!considered[d] || (dst[v] + arc.minl() < dst[d]) )  ) {
                dst[d] = dst[v] + arc.minl();
                par[d] = v;
                considered[d] = true;

                if( !S[d] && !in_queue[d] ) {
                    neigh.push_back(d);
                    in_queue[d] = true;
                }
            }
        }
    }
}

void DistanceFinder2::findDistances(VVI & g, int beg, Mask &S) {
    fill(ALL(considered),false);
    fill(ALL(in_queue),false);
    neigh.clear();

    dst[beg] = 0; par[beg] = -1;
    considered[beg] = true;

    neigh.push_back(beg);

    for( int i=0; i<neigh.size(); i++ ) {
        int v = neigh[i];
        in_queue[v] = false;
        considered[v] = true;

        for( int d : g[v] ) {
            if( !S[d] && (!considered[d] || (dst[v] + 1 < dst[d]) )  ) {
                dst[d] = dst[v] + 1;
                par[d] = v;
                considered[d] = true;

                if( !in_queue[d] ) {
                    neigh.push_back(d);
                    in_queue[d] = true;
                }
            }
        }
    }
}


void DistanceFinder2::findDistancesFBS(VVI & g, int beg, Mask &S, VI & ind_in_S, int vv, VVB & ends) {
    fill(ALL(considered),false);
    fill(ALL(in_queue),false);
    neigh.clear();

    dst[beg] = 0; par[beg] = -1;
    considered[beg] = true;

    neigh.push_back(beg);

    for( int i=0; i<neigh.size(); i++ ) {
        int v = neigh[i];
        in_queue[v] = false;
        considered[v] = true;

        for( int d : g[v] ) {
            if( !S[d] && (!considered[d] || (dst[v] + 1 < dst[d]) )  ) {
                if( ind_in_S[v] != -1 && ind_in_S[d] != -1 && v != vv && d != vv && !ends[v][d] ) continue;

                dst[d] = dst[v] + 1;
                par[d] = v;
                considered[d] = true;

                if( !in_queue[d] ) {
                    neigh.push_back(d);
                    in_queue[d] = true;
                }
            }
        }
    }
}
