//
// Created by sylwe on 21/09/2024.
//

#ifndef DISTANCEFINDER2_H
#define DISTANCEFINDER2_H

#include "Structures.h"

class DistanceFinder2 {
public:
    DistanceFinder2( int N ) {
        this->N = N;
        in_queue = considered = VB(N);
        dst = par = VI(N,-1);
        neigh.reserve(N);
    }

    int getDst( int to ) { return considered[to] ? dst[to] : inf; }
    int getPar(int v) { return considered[v] ? par[v] : inf; }

    void findDistances( GraphSP2 & g, int beg, Mask& S );
    void findDistancesInclusive( GraphSP2 & g, int beg, VB& S );
    void findDistances( VVI & g, int beg, Mask& S );
    void findDistancesFBS(VVI & g, int beg, Mask &S, VI & ind_in_S, int vv, VVB & ends);

    int N;
    VB considered, in_queue;
    VI dst, par, neigh;
};

#endif //DISTANCEFINDER2_H
